Array.prototype.remove = function () {
    var what, a = arguments, L = a.length, ax;
    while (L && this.length) {
        what = a[--L];
        while ((ax = this.indexOf(what)) !== -1) {
            this.splice(ax, 1);
        }
    }
    return this;
};
var districtsScript = districtsScript || function () {
    var isInit = false;
    var districtListingDataTable = null;
    var selectedDistricts = [];

    var init = function () {
        if (isInit) return;
        isInit = true;
        handler();
    };

    var handler = function () {
        districtListDataTable();
        globalScript.initValidator();
        initEditor();

        $("body").on('click', '.select_all', function () { // bulk checked
            var status = this.checked;
            if (status === true) {
                $('#bulk-action-checkbox').prop('checked', true);
                $('body').find(".bulkRow").each(function () {
                    $(this).prop("checked", status);
                    var roleId = $(this).closest('tr').find('.district-id').val();
                    if (selectedDistricts.indexOf(roleId) === -1) {
                        selectedDistricts.push(roleId);
                    }
                });
            } else {
                $(".bulkRow, .select_all").prop('checked', false);
                $('#bulk-action-checkbox').prop('checked', false);
                selectedDistricts = [];
            }
        });

        $('body').on('click', '.bulkRow', function () {
            var status = this.checked;
            var roleId = $(this).closest('tr').find('.district-id').val();
            if (status === true) {
                if (selectedDistricts.indexOf(roleId) === -1) {
                    selectedDistricts.push(roleId);
                }
                $('#bulk-action-checkbox').prop('checked', true);
            } else {
                selectedDistricts.remove(roleId);
            }
            if (selectedDistricts.length === 0) {
                $(".bulkRow, .select_all").prop('checked', false);
            }
        });

        $('body').on('click', '#apply_bulk_actions_btn', function () {
            var bulkOption = $('#bulk_actions').val();
            if (bulkOption === '') {
                $('#bulk_actions_error').html('Please select an action first').show();
            } else {
                if (selectedDistricts.length === 0) {
                    $('#bulk_actions_error').html('Please select district(s) first').show();
                } else {
                    $('#bulk_actions_error').hide();
                    if (bulkOption === 'delete_bulk') {
                        globalScript.showConfirmationAlert(
                            'You want to delete selected district(s)?',
                            function () {
                                deleteDistricts(function () {
                                    toastr.success('District(s) deleted successfully');
                                    districtListDataTable();
                                    $(".bulkRow, .select_all").prop('checked', false);
                                });
                            }
                        )
                    }
                }
            }
        });

        $('body').on('submit', '#create_district_form', function (e) {
            e.preventDefault();
            if ($('#submit_btn').hasClass('disabled')) {
                return false;
            }
            $('#submit_btn').addClass('disabled');
            $('.add_errors').hide();
            $('.add_errors ul').html('');
            var district_name = $('#district_name').val();
            var district_state = $('#district_state').val();
            var district_meta_title = $('#district_meta_title').val();
            var district_meta_keywords = $('#district_meta_keywords').val();
            var district_meta_description = $('#district_meta_description').val();
            var district_full_description = $('#district_full_description').summernote('code');
            var obj = Object.create(globalScript.CREATE_ATTRIBUTE);
            obj.data = {
                'type': 'district',
                'name': district_name,
                'parent_id': district_state,
                'full_desc': district_full_description,
                'meta_title': district_meta_title,
                'meta_keywords': district_meta_keywords,
                'meta_desc': district_meta_description,
            };
            globalScript.ajaxCall(obj).done(function (response) {
                if (response.errors && response.errors.length !== 0) {
                    $('.add_errors').show();
                    $('#submit_btn').removeClass('disabled');
                    _.each(response.errors, function (v, k) {
                        $('.add_errors ul').append('<li>' + v + '</li>');
                    });
                    return false;
                } else {
                    toastr.success(response._metadata.message);
                    $('#addDistrictModal').modal('hide');
                    districtListDataTable();
                }
            });
        });

        $('body').on('submit', '#edit_district_form', function (e) {
            e.preventDefault();
            if ($('#edit_submit_btn').hasClass('disabled')) {
                return false;
            }
            $('#edit_submit_btn').addClass('disabled');
            $('.edit_errors').hide();
            $('.edit_errors ul').html('');
            var districtId = $('#district_id').val();
            var district_name = $('#edit_district_name').val();
            var district_state = $('#edit_district_state').val();
            var district_meta_title = $('#edit_district_meta_title').val();
            var district_meta_keywords = $('#edit_district_meta_keywords').val();
            var district_meta_description = $('#edit_district_meta_description').val();
            var district_full_description = $('#edit_district_full_description').summernote('code');
            var obj = Object.create(globalScript.UPDATE_ATTRIBUTE);
            obj.url = obj.url(districtId);
            obj.data = {
                'name': district_name,
                'parent_id': district_state,
                'full_desc': district_full_description,
                'meta_title': district_meta_title,
                'meta_keywords': district_meta_keywords,
                'meta_desc': district_meta_description,
            };
            globalScript.ajaxCall(obj).done(function (response) {
                if (response.errors && response.errors.length !== 0) {
                    $('#edit_submit_btn').removeClass('disabled');
                    _.each(response.errors, function (v, k) {
                        $('.edit_errors ul').append('<li>' + v + '</li>');
                        $('.edit_errors').show();
                    });
                } else {
                    toastr.success(response._metadata.message);
                    $('#editDistrictModal').modal('hide');
                    districtListDataTable();
                }
            });
        });

        $('body').on('click', '.edit-btn', function () {
            var districtId = $(this).closest('tr').find('.district-id').val();
            var obj = Object.create(globalScript.GET_ATTRIBUTE_DETAILS);
            var url = obj.url(districtId);
            obj.url = url;
            globalScript.ajaxCall(obj).done(function (response) {
                if (response.hasOwnProperty('_metadata') && response._metadata.hasOwnProperty('outcomeCode') && response._metadata.outcomeCode === 0) {
                    $('body').find('#district_id').val(response.records.id);
                    $('body').find('#edit_district_form #edit_district_name').val(response.records.name);
                    $('body').find('#edit_district_form #edit_district_state').selectpicker('val', response.records.parent_id);
                    $('body').find('#edit_district_form #edit_district_meta_title').val(response.records.meta_title);
                    $('body').find('#edit_district_form #edit_district_meta_keywords').val(response.records.meta_keywords);
                    $('body').find('#edit_district_form #edit_district_meta_description').val(response.records.meta_desc);
                    $('body').find('#edit_district_form #edit_district_full_description').summernote("code", response.records.full_desc);
                    $('.edit_errors').hide();
                    $('.edit_errors ul').html('');
                    $('#editDistrictModal').modal('show');
                }
            })
        });

        $('body').on('click', '.delete-btn', function () {
            selectedDistricts = [];
            $(".bulkRow, .select_all").prop('checked', false);
            var districtId = $(this).closest('tr').find('.district-id').val();
            selectedDistricts.push(districtId);
            globalScript.showConfirmationAlert(
                'You want to delete?',
                function () {
                    deleteDistricts(function () {
                        toastr.success('Deleted successfully');
                        districtListDataTable();
                    });
                }
            )
        });

        $('#addDistrictModal').on('hidden.bs.modal', function (e) {
            $('.add_errors').hide();
            $('.add_errors ul').html('');
            $('#district_state').selectpicker('val', '');
            $('#create_district_form').trigger("reset");
            $('#district_full_description').summernote('reset');
        });

        $('#editDistrictModal').on('hidden.bs.modal', function (e) {
            $('.edit_errors').hide();
            $('.edit_errors ul').html('');
            $('#edit_district_form').trigger("reset");
            $('#edit_district_full_description').summernote('reset');
        });
    };

    var deleteDistricts = function (callback) {
        var obj = Object.create(globalScript.DELETE_ATTRIBUTE);
        obj.data = {
            'attribute_ids[]': selectedDistricts
        };
        globalScript.ajaxCall(obj).done(function (response) {
            selectedDistricts = [];
            if (typeof callback == 'function') callback();
        });
    };

    var districtListDataTable = function () {
        if (districtListingDataTable != null) {
            districtListingDataTable.clear().destroy();
        }
        districtListingDataTable = $('#districtsListTable').DataTable({
            "ajax": {
                url: globalScript.APP_URL + "attributes?type=district",
                type: "GET",
                xhrFields: {
                    withCredentials: true
                },
                dataSrc: function (json) {
                    if (json.hasOwnProperty('_metadata') && json._metadata.hasOwnProperty('outcomeCode') && json._metadata.outcomeCode === 4) {
                        window.top.location.href = "login";
                        return;
                    }
                    json.draw = json.records.draw;
                    json.recordsTotal = json.records.recordsTotal;
                    json.recordsFiltered = json.records.recordsFiltered;
                    $('body').find('#module_total_count').html(json.records.recordsTotal);
                    if (json.records.data.length !== 0) {
                        $("body").find(".f_custom_checkbox").css('pointer-events', 'all');
                        $("body").find(".f_custom_card_footer").show();
                    } else {
                        $("body").find(".f_custom_card_footer").hide();
                    }
                    return json.records.data;
                }
            },
            "searching": true,
            "ordering": true,
            "serverSide": true,
            "paging": true,
            "stateSave": false,
            "columns": [
                {
                    "orderable": true,
                    "searchable": false,
                    "data": 'created_at',
                    "visible": false
                },
                {
                    "data": "name",
                    "title": "Title",
                    "name": "name",
                    "searchable": true,
                    "orderable": true
                },
                {
                    "data": "parent",
                    "title": "State",
                    "name": "parent.name",
                    "searchable": false,
                    "orderable": false
                },
                {
                    "data": null,
                    "title": "Actions",
                    "searchable": false,
                    "orderable": false
                }
            ],
            "order": [[0, 'desc']],
            "rowCallback": function (row, data) {
                var tmpl = _.template($('#districtsListTemplate').html());
                $(row).html(tmpl(data));
            }
        });
    };

    var initEditor = function () {
        $('.content_area').summernote({
            onCreateLink: function (originalLink) {
                return originalLink; // return original link
            },
            dialogsInBody: true,
            height: 300,
            tabsize: 2
        });
    };

    return {
        'init': init
    }

}();

$(document).ready(function () {
    districtsScript.init();
});
